//
// Created by zoe on 1/9/23.
//

#ifndef HOST_CENTRAL_MAST_REQUESTINFORMATION_H
#define HOST_CENTRAL_MAST_REQUESTINFORMATION_H

#include <Arduino.h>

struct RequestInformation {
    String method;
    String host;
    String path;
    String body;

    RequestInformation(String method, String host, String path, String body) {
        this->method = method;
        this->host = host;
        this->path = path;
        this->body = body;
    }

    // TODO: Move to configuration file
    const String INFLUXDB_TOKEN =
        "dUh2gbVLv7e3egqocxriDsJQNUacA9qZ5YXsYtdnVAglnHgy4nx-jDVO7nGlSF34BosfnuwnUDaviC7dQeC5RQ==";

    String buildRequest() {
        String request = "";
        request += method + " " + path + " HTTP/1.1\r\n";
        request += "Host: " + host + "\r\n";
        request += "Authorization: Token " + INFLUXDB_TOKEN + "\r\n";
        request += "User-Agent: ESP32\r\n";
        request += "Content-Type: text/plain\r\n";
        request += "Content-Length: " + String(body.length()) + "\r\n";
        request += "\r\n";
        request += body;
        return request;
    }
};

#endif // HOST_CENTRAL_MAST_REQUESTINFORMATION_H
